<html>
<head>
	<title>Kicker Bots</title>
	<link rel="stylesheet" type="text/css" href="../styles.css"/>
</head>
<body>
<div id="content">
	<h2>Kicker Bots</h2>
	<h3>Agent Algorithm</h3>
	<p>
		A kicker agent chooses a visible ball at random and accelerates
		towards it. If no ball is visible the agent sets his acceleration
		to zero.
	</p>
	<h4>Pseudocode</h4>
	<div class="pseudocode">
<pre>visibleBalls = {}
for all visibleObjects
   if visibleObject is ball
      visibleBalls <-- visibleObject
if visibleBalls is not empty
   ball = selectRandom(visibleBalls)
   accelerate towards ball
else
   set acceleration to zero</pre>
	</div>
	<h3>Observed Behavior</h3>
	<p>
		Since a kicker agent doesn't remember which ball he's
		accelerating towards from one moment to the next, if he can see
		multiple balls (e.g. if Number of Balls or Agent Sight is set high),
		he will appear to have a pretty short attention span, since
		the ball he will chose balls randomly each time.
	</p>
	<p>
		The ceasing to accelerate strategy works well when a ball goes
		out of sight, because chances are the agent was accelerating in the
		same direction as the ball at last sighting, and an agent without
		acceleration will bounce around the board just like the ball. To
		see this, turn down the Agent Sight to around 10 or 15, so that if
		there's another agent between him and the ball, an agent probably
		won't be able to see the ball.
	</p>
	<p>
		If there are too many agents or too few balls, the agents will
		end up trapping the balls in the corners and the game ceases to be
		interesting.
	</p>
	<h3>The Applet</h3>
	<applet archive="../dist/appletbots.jar"
	        code="appletbots.balls.BallsApplet"
	        alt="Kicker Applet"
	        width="600"
	        height="450">
		<div>
			If you see this, you need to either enable java, or install the Sun Java
			Virtual Machine in your browser. To do so,
			<a href="http://java.sun.com/getjava/download.html">click here</a>.
		</div>
	</applet>
	<h3>Source Code</h3>
	<ul>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/balls/BallsApplet.java">BallsApplet.java</a>
		</li>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/balls/Ball.java">Ball.java</a>
		</li>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/balls/Kicker.java">Kicker.java</a>
		</li>
	</ul>
	<a href="../" class="return">Back to the Applet Bots Home</a>
</div>
<div class="official">
	The official version of this file is at <a href="http://applet-bots.sourceforge.net/applets/kicker.html">applet-bots.sourceforge.net</a>
	<a href="http://sourceforge.net" class="sf-logo"><img border="0" alt="SourceForge.net Logo" src="http://sflogo.sourceforge.net/sflogo.php?group_id=205988&amp;type=1"/></a>
</div>
</body>
</html>
